#include <iostream>
#include <windows.h>

#include "glutNew.h" 

using namespace std;

int estado = 0;

typedef struct  // Struct para armazenar um ponto
{
	int X,Y;
} TPoint;

int contador = 0;
TPoint Poli[20];
TPoint ponto;

// Funo callback chamada quando o tamanho da janela  alterado 
void AlteraTamanhoJanela(GLsizei w, GLsizei h)
{ 
    // Especifica as dimenses da Viewport
    glViewport(0, 0, w, h);

    // Inicializa o sistema de coordenadas
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D(0,700,0,600);
}

void Desenha(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

     glMatrixMode(GL_MODELVIEW);
     glLoadIdentity();

	if(contador > 1) {
		glBegin(GL_LINE_STRIP);
		glColor3f(1.0, 1.0, 1.0);
		for(int c=0; c < contador; c++)
			glVertex2i(Poli[c].X, Poli[c].Y);
                          
		glEnd();
	}
	glFlush();
		 
}

void Desenha2(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

     glMatrixMode(GL_MODELVIEW);
     glLoadIdentity();
                   
	 if(estado == 0){
        glBegin(GL_LINE_LOOP);
		glColor3f(1.0, 1.0, 1.0);

		for(int c=0; c < contador; c++){
            glVertex2i(Poli[c].X, Poli[c].Y);
		}
                           
		glEnd();
		estado = 1;
	 }
	 else
		 if(estado == 1){
			 glBegin(GL_LINE_LOOP);
			 glColor3f(1.0, 1.0, 1.0);

			 for(int c=0; c < contador; c++){
				glVertex2i(Poli[c].X, Poli[c].Y);
			 }
                           
	         glEnd();
			 
			 glBegin(GL_POINTS);
			 glColor3f(1.0, 1.0, 1.0);

			 glVertex2i(ponto.X, ponto.Y);

			 glEnd();
			
		 }
		  glFlush();

}


// Funo callback chamada para gerenciar eventos do mouse
void GerenciaMouse(int button, int state, int x, int y){
	if(estado == 0){
		if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN){
			Poli[contador].X = x;
			Poli[contador].Y = 600-y;
			cout << "x= " << x << " y= " << 600-y << endl;
			contador++;	
			cout << "Numero de vertices: " << contador << endl;
		}
		if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN){
			glutDisplayFunc(Desenha2);
		}
		
	}
	else
		if(estado == 1){
			if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN){
				ponto.X = x;
				ponto.Y = 600-y;
			}
		}
	glutPostRedisplay();
}

int main(){

	 glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
     glutInitWindowSize(700,600);
     glutInitWindowPosition(150,50);
     glutCreateWindow("Gerador de Polgonos");
	 glutDisplayFunc(Desenha);
	 glutReshapeFunc(AlteraTamanhoJanela);
	 glutMouseFunc(GerenciaMouse);
	 glutMainLoop();
	 return 0;

}
